﻿<?php
/*
 *      ListImgEnvoieFTP V0.20060909
 *
 *      Copyright 2007 Jonas Fourquier <http://jonas.tuxfamily.org>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 *
 *         ChangeLog
 *         09-09-2007 : Création et mise en ligne
 */

/*** CONFIGURATION ***/
$conf = array( //ne pas toucher à cette ligne
    'nbimg' => 6,               //-> Nombre d'image par page
    'largCaseImg' => '45%',     //-> Largeur des cases contenant les images (px, em ou %)
    'formUpload' => False,      //-> Affiche un forumulaire d'uploade ATTENTION*
    'delFile' => False,         //-> Permet de supprimer les fichier ATTENTION*
                                //   ATTENTION* N'IMPORTE QUI POURRA UTILISER CES
                                //   FONCTIONS mais vous pouvez protéger la page grâce
                                //   à des .htaccess et .htpasswd
    'RSSfeed' => 1,             //-> Syndication RSS2.0 - 0:desactivé, 1:alléger, 2:complet
    'Xmin' => 160,              //-> Largeur des miniatures en px
    'Ymin' => 120,              //-> Hauteur des miniatures en px
    'GDresampled' => True,      //-> Rééchantillonne les miniatures (meilleur qualité d'image
                                //   mais certain serveur bloque cette fonction)
    'jpgQuali' => 75,            //-> Qualitée des jpeg
    'extOK' => array('jpg','JPG','jpeg','JPEG','png','PNG','gif','GIF'), //-> Liste des extentions acceptée

    'code' => array( //ne pas toucher à cette ligne

    //-> Balise d'insertion ('avec miniature', 'sans miniature') (%min% = miniature, %big% = original, %name = nom)
        'BBcode' => array('[url=%big%][img]%min%[/img][/url]','[img]%big%[/img]'),
        'html' => array(htmlentities('<a href="%big%"><img src="%min%" alt="%name%"></a>'),htmlentities('<img src="%min%" alt="%name%">')),
        'wikiDC' => array('[((%min%))|%big%]','((%big%))')
        /*'autres' => array('code_cliquable','code_non_clickable')*/ )
    );
/*** FIN CONFIGURATION ***/

ini_set ('magic_quotes_gpc', 1);

function envoi() {
    global $conf;

    $type = substr(strrchr($_FILES['file']['name'], '.'), 1);

    //Envoi
    //$itisimg = 1; //c'est une image (initialisation de la variable)

    // vérifications de l'extention
    if(!in_array($type, $conf['extOK']))
    {
        echo 'Erreur:  <code>'.$_FILES['file']['name'].'</code> N\'est pas un fichier accepter !<br/>';
        return False;
    }
    // vérification de la taille max
    /*elseif( file_exists($_FILES['file']['tmp_name'])
        and filesize($_FILES['file']['tmp_name']) > ini_get('post_max_size'))
    {
        echo 'Erreur: Fichier plus gros que '.ini_get('post_max_size').'!<br />';
        return False;
    }*/
    // si c'est une image pas trop grosse => envoi
    else
    {
        // COPIE FICHIER
        $big = basename($_FILES['file']['name']);
        // nettoyage nom fichier
        // enlever les accents
        $big = strtr($big,
            'ÀÁÂÃÄÅÇÈÉÊËÌÍÎÏÒÓÔÕÖÙÚÛÜÝàáâãäåçèéêëìíîïðòóôõöùúûüýÿ',
            'AAAAAACEEEEIIIIOOOOOUUUUYaaaaaaceeeeiiiioooooouuuuyy');
        // remplacer les caracteres autres que lettres, chiffres et point par _
        $big = /*dirname(__FILE__).'/'.*/preg_replace('/([^.a-z0-9]+)/i', '_', $big);
        // copie du fichier
        move_uploaded_file($_FILES['file']['tmp_name'], $big);
        chmod ($big,0644);
    }

    return creerMin($big);
}

function creerMin($big) {
    global $conf;

    $type = substr(strrchr($big, '.'), 1);

    if (in_array($type, $conf['extOK']))
    {
        $jpg = array('jpg','JPG','jpeg','JPEG');
        $gif = array('gif','GIF');
        $png = array('png','PNG');

        chdir(dirname(__FILE__));

        // Création de l'image en fonction de l'extention
        if (in_array($type, $jpg))
            $bigTmp = ImageCreateFromJpeg($big);    //les jpeg
        elseif (in_array($type, $gif))
            $bigTmp = ImageCreateFromGif($big);        //les gif
        elseif (in_array($type, $png))
            $bigTmp = ImageCreateFromPng($big);        // les png
        else
        {
            return False;
        }
        //Resolution de l'image
        $Xbig = imagesx($bigTmp);
        $Ybig = imagesy($bigTmp);
        $Xmin = $conf['Xmin'];
        $Ymin = $conf['Ymin'];

        //Résolution de la miniature
        if ($Xbig > $Xmin || $Ybig > $Ymin) {
            if ($Xbig/$Ybig <= $Xmin / $Ymin) //image trop haute
                $Ymin = ($Ybig / $Xbig) * $Xmin;
            else
                $Xmin = ($Xbig / $Ybig) * $Ymin;
            $minTmp = ImageCreateTrueColor ($Xmin, $Ymin)
            or die ('Erreur lors de la création de une image vide');
        } else {
            return False;
        }

        //Redimm de l'image
        if ($config['GDresampled'])
            ImageCopyResampled($minTmp, $bigTmp, 0, 0, 0, 0, $Xmin, $Ymin, $Xbig, $Ybig);
        else
            ImageCopyResized($minTmp, $bigTmp, 0, 0, 0, 0, $Xmin, $Ymin, $Xbig, $Ybig);

        //Conversion
        $min = 'min_'.$big;
        if (in_array($type, $jpg))
            ImageJpeg($minTmp, $min, $conf['jpgQuali']);
        elseif (in_array($type, $gif))
            ImageGif($minTmp, $min);
        else
            ImagePng($minTmp, $min);

        return True;
    } else {
        return False;
    }
}

function unit($octets,$prec=2) {
    if ($octets>1048576)
        return round($octets/1048576,$prec).' Mo';
    else
        return round($octets/1024,$prec).' Ko';
}

function infoImg($img) {
    global $conf, $url, $page, $tri;

    $reso = getimagesize($img['name']);

    $txt = "
        <ul>
            <li><label>Taille:</label>".$reso[0]."x".$reso[1].", ".unit($img['size'])." (<a href='".$img['name']."'>voir</a>)</li>
            <li><label>Dates:</label>".date("d/m/Y à H:i",$img['date']).' - '.$img['date']."</li>";
    if ($img['min']) {
        $infoMin = getimagesize('min_'.$img['name']);
        $txt .= "<li><label>Miniature:</label>".$infoMin[0]."x".$infoMin[1].", ".unit(filesize('min_'.$img['name']))." (<a href='min_".$img['name']."'>voir</a>";
        if ($conf['delFile'])
            $txt .= " - <a href='?p=$page&tri=$tri&del=min_".$img['name']."'>supprimer</a>";
        $txt .= ")</li>";
    } elseif ($reso[0] <= $conf['Xmin'] && $reso[1] <= $conf['Ymin']) {
        $txt .= "<li><label>Miniature:</label>Inutile</li>";
    } else {
        $txt .= "<li><label>Miniature:</label>aucune (<a href='?p=$page&tri=$tri&min=".$img['name']."'>créer</a>)</li>";
    }
    if ($img['min'])
        $keyno = 0;
    else
        $keyno = 1;
    foreach ($conf['code'] as $name => $code)
        $txt .= "<li><label for='$name$i'>$name: </label><input class='code' id='$name$i' onClick='select();' type='text' value='".str_replace(
            array('%big%',            '%min%',                 '%titre%'),
            array($url.$img['name'],$url.'min_'.$img['name'],$img['name']),
            $code[$keyno])."'></span></li>";
    $txt .= "</ul>";

    return $txt;
}


//recup des $_GET
$type = addslashes($_GET['type']);
$del = addslashes($_GET['del']);
$min = addslashes($_GET['min']);
if ($_POST['page'])
    $page = addslashes($_POST['page']);
else
    $page = addslashes($_GET['p']);
if ($page == '')
    $page=1;
$tri = addslashes($_GET['tri']);
if ($tri == '' || $type == 'rss')
    $tri = 'daterev';

$reverse = addslashes($_GET['reverse']);

$url = "http://" . $_SERVER["SERVER_NAME"] . $_SERVER["PHP_SELF"];
$url = substr($url,0,strrpos($url,'/')+1);



//ACTION PAGE

//Envoi de fichier ****************************************************
if ($_POST['envoi'] && $conf['formUpload']) {
    if (envoi())
        $msg = "<p class='ok''>L'envoi du fichier a réussi.</p>";
    else
        $msg = "<p class='ko'>Erreur lors de l'envoi du fichier.</p>";
//Supression de fichier ***********************************************
} else {
    if ($del && $conf['delFile']) {
        if (in_array(substr(strrchr($del, '.'), 1), $conf['extOK']) && !strrchr($del,'/')) {
            if (unlink(dirname(__FILE__).'/'.$del))
                $msg = "<p class='ok'>La supression de <code>$del</code> a réussi.</p>";
            else
                $msg = "<p class='ko'>Erreur lors de la supression de <code>$del</code>.</p>";
            if (file_exists('min_'.$del))
            {
                if (unlink(dirname(__FILE__).'/'.'min_'.$del))
                    $msg = "<p class='ok'>La supression de la miniature de <code>$del</code> a réussi.</p>";
                else
                    $msg = "<p class='ko'>Erreur lors de la supression de la miniature de <code>$del</code>.</p>";
            }
        } else {
            $msg = "<p class='ko'>Ce fichier ne peux pas être effacer.</p>";
        }
    }
//miniature
    if ($min) {
        if (!file_exists('min_'.$min) && !strrchr($min,'/')) {
            if (creerMin($min))
                $msg = "<p class='ok'>La création de la miniature de <code>$min</code>
                    a réussi.</p>";
            else
                $msg = "<p class='ko'>Erreur lors de la création de la miniature de <code>$min</code>.</p>";
        } else {
            $msg = "<p class='ko'>La miniature de <code>$min</code> existe déjà ou ne peut être créée.</p>";
        }
    }
}





//lire le contenu du dossier
$dir = opendir("./");
while ($f = readdir($dir)) {
    if(is_file($rep.$f)) {
        if (substr($f,0,4) != 'min_'
            && in_array(substr($f,strrpos($f,'.')+1),$conf['extOK'])) {
            //Cherche les info du fichier
            //echo "<pre>";
            //print_r(date("d/m/Y à h:i",stat($f)[8]));
            $infoFile = array(
                   'name' => $f,
                   'size' => filesize($f),
                   'date' => filemtime($f),
                   'min' => file_exists('min_'.$f)
                   );
            //tri des image
            switch($tri) {
                case 'name' :
                    $list[$f] = $infoFile;
                    break;
                case 'namerev' :
                    $list[$f] = $infoFile;
                    break;
                case 'size' :
                    $list[$infoFile['size']] = $infoFile;
                    break;
                 case 'sizerev' :
                    $list[$infoFile['size']] = $infoFile;
                    break;
                case 'date' :
                    $list[$infoFile['date']] = $infoFile;
                    break;
                case 'dateref' :
                    $list[$infoFile['date']] = $infoFile;
                    break;
                default :
                    $list[$infoFile['date']] = $infoFile;
                    break;
            }
        }
    }
}
//trier
if (in_array ($tri,array('name','size','date')))
    ksort($list);
else
    krsort($list);
/*
echo "<pre>";
foreach ($list as $key => $array)
    echo "$key\n";
echo "</pre>";*/

//fils RSS
if ($type == 'rss' && $conf['RSSfeed'])
{
    //$url = addslashes($_GET['url']);

    echo "<?xml version='1.0' encoding='UTF-8'?>
        <rss version='2.0'>
            <channel>

                <title>ListImgEnvoieFTP - $url</title>
                <link>$url</link>
                <description>".htmlentities("Les images sur $url")."</description>
                ";
    $imgNo = 0;
    foreach ($list as $img) {
        if (file_exists('min_'.$img['name']))
            $min = 'min_'.$img['name'];
        else
            $min = $img['name'];

        $imgPage = round($imgNo/$conf['nbimg'] + 0.5);
        $imgNo ++;

        echo "
                <item>
                    <title>".$img['name']."</title>
                    <link>$url?p=$imgPage</link>
                    <guid isPermaLink='true'>$url/".$img['name']."</guid>
                    <enclosure url='".$img['name']."'></enclosure>
                    <description>".
                        htmlentities("<a href=$url?p=$imgPage'>
                            <img style='max-height:120px;max-weight:160px;float:left' src='$min'>
                            </a>");
        if ($conf['RSSfeed'] == 2)
            echo        htmlentities(infoImg($img));
        echo "
                    </description>
                    <pubDate>".date("r",$img['date'])."</pubDate>
                </item>
                ";
    }
    echo "
            </channel>
        </rss>";
} else {
//Affichage page ======================================================
echo "<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN' 'http://www.w3.org/TR/html4/loose.dtd'>
<html>
<head>
    <title>ListImgEnvoieFTP - $url</title>
    <meta name='GENERATOR' content='Geany'>
    <meta name='AUTHOR' content='Jonas Fourquier'>
    <meta http-equiv='Content-Type' content='text/html; charset=UTF-8'>";
if ($conf['RSSfeed'])
    echo "<link rel='alternate' type='application/rss+xml' title='ListImgEnvoieFTP - $url' href='$url?type=rss&url=$url' />";
echo "
    <style>
        body {
            font-family: Verdana, Helvetica, Arial, Helvetica, Geneva, sans-serif;
            font-size: 80%;
            }
        div.img {
            border: 1px solid gray;
            margin : 1em;
            padding : .5em;
            width : ".$conf['largCaseImg'].";
            height : 160px;
            float : left;
            }
        div.cadreimg {
            text-align : center;
            vert-align: middle;
            border: none;
            float: left;
            height:100%;
            width: 160px;
            margin-right: 2em;
            margin-top : 1em;
            }
        div.form {
            width: 30em;;
            margin : 1em;
            padding-top : 2em;
        }
        div.foot {
            margin : 1em;
            margin-top:2em;
            font-size: 90%;
            color: gray;
            }
        p {
            margin-left: 3em
            /*text-align :center*/
            }
        p.ok {
            background-color: #BFFFBF;
            padding : 0.5em;
            border: 1px solid #00BA00;
            }
        p.ko {
            background-color: #FFA6A6;
            padding : 0.5em;
            border: 1px solid #C50000;
            }
        a {
            text-decoration: none;
            }
        a:hover {
            text-decoration: underline;
            }
        a.del {
            float:right;
            }
        a:hover.del {
            text-decoration: underline blink;
            }
        span.tri {
            color: gray;
            border:1px solid grey;
            background-color:#D0D0D0;
            margin-left: -1px;
            padding: 0 2px 2px 2px;
        }
        a.tri {
            color: gray;
            border:1px solid gray;
            margin-left : -1px;
            padding: 0 2px 2px 2px;
            }
        a:hover.tri {
            text-decoration : None;
            background-color : #E4DDDD;
        }
        a.page {
            color: gray;
            width : 50px;
            border:1px solid gray;
            margin-left: -1px;
            padding: 0 5px 0 5px;
            }
        a:hover.page {
            text-decoration : None;
            background-color : #E4DDDD;
        }
        a.foot {
            color: gray;
            border-bottom : gray dotted 1px;
            }
        h1 {
            margin-left: 1em
            }
        img {
            max-width: 160px;
            max-height: 120px;
            position: relative;
            margin: auto;
            /*float : left;
            margin-right : 2em;
            margin-top : 1em;
            padding: auto;*/
            border: solid 1px gray;
            }
        img:hover {
            border: solid 1px black;
            }
        ul {
            list-style-type: square;
            }
        label {
            display: inline;
            float: left;
            width: 6em
            }
        input {
            border: solid 1px gray;
            top: -5px;
            }
        input.code {
            border-color: gray #E4DDDD #E4DDDD gray;
            left : -10px;
            width : 25em;
            height : 1.2em;
            font-size: 80%;
            }
        input.page {
            font-size: 80%;
            width : 2em;
            }
        fieldset {
            float:left;
            margin: 1em;
        }

    </style>
</head>
<body><h1>ListImgEnvoieFTP - $url</h1>";

echo $msg; //affichage de message divers crer lors de l'execution du script

$nbimg = count($list);
echo "<p>Nombre d'images : $nbimg <br/>Classer par : ";

function actif($value,$text) {
    global $tri, $page;
    if ($tri == $value)
        return "<span class='tri'>$text</span>";
    else
        return "<a class='tri' href='?p=$page&tri=$value'>$text</a>";
}

echo "
    Nom     ".actif('name','&darr;').actif('namerev','&uarr;')." |
    Taille  ".actif('size','&darr;').actif('sizerev','&uarr;')." |
    Date    ".actif('date','&darr;').actif('daterev','&uarr;')."
    </p>";

//Page
$nbPage = $nbimg / $conf['nbimg'];
if (!is_int($nbPage))
    $nbPage = round($nbPage + 0.5);

echo "<form method='post' action='$url?p=$page&tri=$tri&reverse=$reverse'>
    <p>Page : ";
if ($page != 1)
    echo '<a class="page"  href="?tri='.$tri.'&p='.($page-1).'">&larr;</a>';
echo "<a class='page' href='?p=$page&tri=$tri'>$page/$nbPage</a>";
if ($page != $nbPage)
    echo '<a class="page" href="?tri='.$tri.'&p='.($page+1).'">&rarr;</a>';
echo " Aller à la page
    <input class='page' type='text' name='page'>
    <input class='page' type='submit' value='go'></p></form>";

$i = 0;
$i_start = $conf['nbimg']*($page-1);
$i_end = $conf['nbimg']*$page -1;
if ($i_end > $nbimg)
    $i_end = $nbimg;

echo "<div class='imgs'>";

foreach ($list as $img)
{
    if ($i_start <= $i && $i <= $i_end)
    {
        echo "<div class='img'>";
        if ($conf['delFile'])
            echo "<a class='del' href='?p=$page&tri=$tri&del=".$img['name']."'>[Supprimer]</a>";

        echo "<a href='".$img['name']."'><strong>".$img['name']."</strong></a><div class='cadreimg'>";
        if ($img['min'])
            echo "<a class='img' href='".$img['name']."'><img src='min_".$img['name']."'></a>";
        else
            echo "<a class='img' href='".$img['name']."'><img src='".$img['name']."'></a>";

        echo "</div>".infoImg($img); //afficher les puces info image

        echo "</div>";
    }
    $i ++;
}
echo "</div>";

if ($conf['formUpload'])
    echo "<div class='form'>
        <form name='boite' method='post' action='$url?p=$page&tri=$tri&reverse=$reverse'
            enctype='multipart/form-data' accept='image/png, image/gif, image/jpg'>
        Envoyer une image :
        <label for='file'></label><input type='file' name='file'/> <input type='submit' name='envoi' value='Envoyer'>
        </form>
        </div>";


echo "
<div class='foot'>ListImgEnvoieFTP est un progamme distribué selon les termes
de la <a class='foot' href='http://www.gnu.org/licenses/gpl.html'>GNU GPL</a>.
Contact et téléchargement : <a class='foot' href='http://jonas.tuxfamily.org/wiki/phpdivers/listimgenvoieftp'>jonas.tuxfamily.org</a></div>";
echo "</body></html>";
}
?>
